# -*- coding: utf-8 -*-

import sys
import math
from PyQt4.QtCore import *
from PyQt4.QtGui import *
from PyQt4.uic import *
from types import *

points = []
img = QImage("test.png")
br = QBrush(Qt.black)
br.setStyle(Qt.SolidPattern)
scale = 1.0
angle = 0.0 # Bogenmaß
shiftX = 0.0
shiftY = 0.0

def handleEvent(self, event):
    global scale, angle, shiftX, shiftY
    if event.type() in [QEvent.TouchBegin, QEvent.TouchUpdate, \
                                            QEvent.TouchEnd]:
        tp = event.touchPoints()
        points[:] = []
        if event.type() != QEvent.TouchEnd:
            for p in tp:
                points.append(p.pos())
        if len(tp) == 2 and tp[0].state() == Qt.TouchPointMoved \
                        and tp[1].state() == Qt.TouchPointMoved:
            pOneNew = tp[0].pos()
            pTwoNew = tp[1].pos()
            pOneOld = tp[0].lastPos()
            pTwoOld = tp[1].lastPos()
            
            diffNew = pOneNew - pTwoNew
            diffOld = pOneOld - pTwoOld
            scaleD = math.sqrt((diffNew.x()**2+diffNew.y()**2)/(diffOld.x()**2+diffOld.y()**2))
            scale *= scaleD
            angleD = math.atan2(diffNew.y(),diffNew.x())-math.atan2(diffOld.y(),diffOld.x())
            angle += angleD
            shiftX = pOneNew.x() - scaleD*(math.cos(angleD)*(pOneOld.x()-shiftX)-math.sin(angleD)*(pOneOld.y()-shiftY))
            shiftY = pOneNew.y() - scaleD*(math.sin(angleD)*(pOneOld.x()-shiftX)+math.cos(angleD)*(pOneOld.y()-shiftY))
        self.update()
    elif event.type() == QEvent.Paint:
        painter = QPainter(self)
        painter.translate(shiftX, shiftY)
        painter.rotate(angle * 180.0 / math.pi)
        painter.scale(scale, scale)
        painter.drawImage(QPoint(0,0), img)
        painter.resetTransform()        
        painter.setBrush(br)
        for q in points:
            painter.drawEllipse(q, 20.0, 20.0)
    return True

app = QApplication(sys.argv)
w = loadUi("touch.ui")

app.setOverrideCursor(Qt.BlankCursor)
w.widget.setAttribute(Qt.WA_AcceptTouchEvents)
w.widget.event = MethodType(handleEvent, w.widget)

w.show()
sys.exit(app.exec_())